3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # The function takes at most 2 arguments. The first argument is the
34 # URL that navigates to the submodule origin repo. When relative, this URL
35 # is relative to the superproject origin URL repo. The second up_path
36 # argument, if specified, is the relative path that navigates
37 # from the submodule working tree to the superproject working tree.
39 # The output of the function is the origin URL of the submodule.
41 # The output will either be an absolute URL or filesystem path (if the
42 # superproject origin URL is an absolute URL or filesystem path,
43 # respectively) or a relative file system path (if the superproject
44 # origin URL is a relative file system path).
46 # When the output is a relative file system path, the path is either
47 # relative to the submodule working tree, if up_path is specified, or to
48 # the superproject working tree otherwise.
49 resolve_relative_url ()
51 remote=$(get_default_remote)
52 remoteurl=$(git config "remote.$remote.url") ||
53 remoteurl=$(pwd) # the repository is its own authoritative upstream
55 remoteurl=${remoteurl%/}
68 remoteurl="./$remoteurl"
79 remoteurl="${remoteurl%/*}"
82 remoteurl="${remoteurl%:*}"
86 if test -z "$is_relative" || test "." = "$remoteurl"
88 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
102 remoteurl="$remoteurl$sep${url%/}"
103 echo "${is_relative:+${up_path}}${remoteurl#./}"
107 # Get submodule info for registered submodules
108 # $@ = path to limit submodule list
112 git ls-files --error-unmatch --stage -- "$@" |
115 my ($null_sha1) = ("0" x 40);
118 my ($mode, $sha1, $stage, $path) =
119 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
120 next unless $mode eq "160000";
122 if (!$unmerged{$path}++) {
123 print "$mode $null_sha1 U\t$path\n";
133 # Map submodule path to submodule name
139 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
141 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
142 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
143 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
145 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
152 # Prior to calling, cmd_update checks that a possibly existing
153 # path is not a git repository.
154 # Likewise, cmd_add checks that path does not exist at all,
155 # since it is the location of a new submodule.
163 if test -n "$GIT_QUIET"
170 name=$(module_name "$sm_path" 2>/dev/null)
171 test -n "$name" || name="$sm_path"
172 base_name=$(dirname "$name")
174 gitdir=$(git rev-parse --git-dir)
175 gitdir_base="$gitdir/modules/$base_name"
176 gitdir="$gitdir/modules/$name"
181 rm -f "$gitdir/index"
183 mkdir -p "$gitdir_base"
184 git clone $quiet -n ${reference:+"$reference"} \
185 --separate-git-dir "$gitdir" "$url" "$sm_path" ||
186 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
189 a=$(cd "$gitdir" && pwd)/
190 b=$(cd "$sm_path" && pwd)/
191 # normalize Windows-style absolute paths to POSIX-style absolute paths
192 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
193 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
194 # Remove all common leading directories after a sanity check
195 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
196 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
198 while test "${a%%/*}" = "${b%%/*}"
203 # Now chop off the trailing '/'s that were added in the beginning
207 # Turn each leading "*/" component into "../"
208 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
209 echo "gitdir: $rel/$a" >"$sm_path/.git"
211 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
212 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
216 # Add a new submodule to the working tree, .gitmodules and the index
220 # optional branch is stored in global branch variable
224 # parse $args after "submodule ... add".
229 case "$2" in '') usage ;; esac
240 case "$2" in '') usage ;; esac
241 reference="--reference=$2"
265 if test -z "$sm_path"; then
266 sm_path=$(echo "$repo" |
267 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
270 if test -z "$repo" -o -z "$sm_path"; then
274 # assure repo is absolute or relative to parent
277 # dereference source url relative to parent's url
278 realrepo=$(resolve_relative_url "$repo") || exit
285 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
290 # multiple //; leading ./; /./; /../; trailing /
291 sm_path=$(printf '%s/\n' "$sm_path" |
301 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
302 die "$(eval_gettext "'\$sm_path' already exists in the index")"
304 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
306 eval_gettextln "The following path is ignored by one of your .gitignore files:
308 Use -f if you really want to add it." >&2
312 # perhaps the path exists and is already a git repo, else clone it
313 if test -e "$sm_path"
315 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
317 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
319 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
324 module_clone "$sm_path" "$realrepo" "$reference" || exit
328 # ash fails to wordsplit ${branch:+-b "$branch"...}
330 '') git checkout -f -q ;;
331 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
333 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
335 git config submodule."$sm_path".url "$realrepo"
337 git add $force "$sm_path" ||
338 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
340 git config -f .gitmodules submodule."$sm_path".path "$sm_path" &&
341 git config -f .gitmodules submodule."$sm_path".url "$repo" &&
342 git add --force .gitmodules ||
343 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
347 # Execute an arbitrary command sequence in each checked out
350 # $@ = command to execute
354 # parse $args after "submodule ... foreach".
376 # dup stdin so that it can be restored when running the external
377 # command in the subshell (and a recursive call to this function)
381 while read mode sha1 stage sm_path
383 if test -e "$sm_path"/.git
385 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
386 name=$(module_name "$sm_path")
388 prefix="$prefix$sm_path/"
390 # we make $path available to scripts ...
394 if test -n "$recursive"
396 cmd_foreach "--recursive" "$@"
399 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
405 # Register submodules in .git/config
407 # $@ = requested paths (default to all)
411 # parse $args after "submodule ... init".
433 while read mode sha1 stage sm_path
435 name=$(module_name "$sm_path") || exit
437 # Copy url setting when it is not set yet
438 if test -z "$(git config "submodule.$name.url")"
440 url=$(git config -f .gitmodules submodule."$name".url)
442 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
444 # Possibly a url relative to parent
447 url=$(resolve_relative_url "$url") || exit
450 git config submodule."$name".url "$url" ||
451 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
453 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
456 # Copy "update" setting when it is not set yet
457 upd="$(git config -f .gitmodules submodule."$name".update)"
459 test -n "$(git config submodule."$name".update)" ||
460 git config submodule."$name".update "$upd" ||
461 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
466 # Update each submodule path to correct revision, using clone and checkout as needed
468 # $@ = requested paths (default to all)
472 # parse $args after "submodule ... update".
493 case "$2" in '') usage ;; esac
494 reference="--reference=$2"
495 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
521 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
527 cmd_init "--" "$@" || return
533 while read mode sha1 stage sm_path
537 echo >&2 "Skipping unmerged submodule $sm_path"
540 name=$(module_name "$sm_path") || exit
541 url=$(git config submodule."$name".url)
542 if ! test -z "$update"
544 update_module=$update
546 update_module=$(git config submodule."$name".update)
549 if test "$update_module" = "none"
551 echo "Skipping submodule '$sm_path'"
557 # Only mention uninitialized submodules when its
558 # path have been specified
560 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
561 Maybe you want to use 'update --init'?")"
565 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
567 module_clone "$sm_path" "$url" "$reference"|| exit
568 cloned_modules="$cloned_modules;$name"
571 subsha1=$(clear_local_git_env; cd "$sm_path" &&
572 git rev-parse --verify HEAD) ||
573 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
576 if test "$subsha1" != "$sha1"
579 # If we don't already have a -f flag and the submodule has never been checked out
580 if test -z "$subsha1" -a -z "$force"
585 if test -z "$nofetch"
587 # Run fetch only if $sha1 isn't present or it
588 # is not reachable from a ref.
589 (clear_local_git_env; cd "$sm_path" &&
590 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
591 test -z "$rev") || git-fetch)) ||
592 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
595 # Is this something we just cloned?
596 case ";$cloned_modules;" in
598 # then there is no local change to integrate
603 case "$update_module" in
606 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
607 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
608 must_die_on_failure=yes
612 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
613 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
614 must_die_on_failure=yes
617 command="git checkout $subforce -q"
618 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
619 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
623 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
626 elif test -n "$must_die_on_failure"
628 die_with_status 2 "$die_msg"
630 err="${err};$die_msg"
635 if test -n "$recursive"
637 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
641 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
644 err="${err};$die_msg"
647 die_with_status $res "$die_msg"
674 git describe "$2" 2>/dev/null ||
675 git describe --tags "$2" 2>/dev/null ||
676 git describe --contains "$2" 2>/dev/null ||
677 git describe --all --always "$2"
680 test -z "$revname" || revname=" ($revname)"
683 # Show commit summary for submodules in index or working tree
685 # If '--cached' is given, show summary between index and given commit,
686 # or between working tree and given commit
688 # $@ = [commit (default 'HEAD'),] requested paths (default all)
695 # parse $args after "submodule ... summary".
709 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
731 test $summary_limit = 0 && return
733 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
737 elif test -z "$1" -o "$1" = "HEAD"
739 # before the first commit: compare with an empty tree
740 head=$(git hash-object -w -t tree --stdin </dev/null)
741 test -z "$1" || shift
749 die "$(gettext "The --cached option cannot be used with the --files option")"
755 # Get modified modules cared by user
756 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
757 sane_egrep '^:([0-7]* )?160000' |
758 while read mod_src mod_dst sha1_src sha1_dst status name
760 # Always show modules deleted or type-changed (blob<->module)
761 test $status = D -o $status = T && echo "$name" && continue
762 # Also show added or modified modules which are checked out
763 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
768 test -z "$modules" && return
770 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
771 sane_egrep '^:([0-7]* )?160000' |
773 while read mod_src mod_dst sha1_src sha1_dst status name
775 if test -z "$cached" &&
776 test $sha1_dst = 0000000000000000000000000000000000000000
780 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
782 100644 | 100755 | 120000)
783 sha1_dst=$(git hash-object $name)
789 eval_gettextln "unexpected mode \$mod_dst" >&2
796 test $mod_src = 160000 &&
797 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
800 test $mod_dst = 160000 &&
801 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
805 case "$missing_src,$missing_dst" in
807 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
810 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
813 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
818 if test $mod_src = 160000 -a $mod_dst = 160000
820 range="$sha1_src...$sha1_dst"
821 elif test $mod_src = 160000
827 GIT_DIR="$name/.git" \
828 git rev-list --first-parent $range -- | wc -l
830 total_commits=" ($(($total_commits + 0)))"
834 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
835 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
838 blob="$(gettext "blob")"
839 submodule="$(gettext "submodule")"
840 if test $mod_dst = 160000
842 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
844 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
847 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
851 # Don't give error msg for modification whose dst is not submodule
852 # i.e. deleted or changed to blob
853 test $mod_dst = 160000 && echo "$errmsg"
855 if test $mod_src = 160000 -a $mod_dst = 160000
858 test $summary_limit -gt 0 && limit="-$summary_limit"
859 GIT_DIR="$name/.git" \
860 git log $limit --pretty='format: %m %s' \
861 --first-parent $sha1_src...$sha1_dst
862 elif test $mod_dst = 160000
864 GIT_DIR="$name/.git" \
865 git log --pretty='format: > %s' -1 $sha1_dst
867 GIT_DIR="$name/.git" \
868 git log --pretty='format: < %s' -1 $sha1_src
874 if test -n "$for_status"; then
875 if [ -n "$files" ]; then
876 gettextln "# Submodules changed but not updated:"
878 gettextln "# Submodule changes to be committed:"
881 sed -e 's|^|# |' -e 's|^# $|#|'
887 # List all submodules, prefixed with:
888 # - submodule not initialized
889 # + different revision checked out
891 # If --cached was specified the revision in the index will be printed
892 # instead of the currently checked out revision.
894 # $@ = requested paths (default to all)
898 # parse $args after "submodule ... status".
923 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
928 while read mode sha1 stage sm_path
930 name=$(module_name "$sm_path") || exit
931 url=$(git config submodule."$name".url)
932 displaypath="$prefix$sm_path"
935 say "U$sha1 $displaypath"
938 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
940 say "-$sha1 $displaypath"
943 set_name_rev "$sm_path" "$sha1"
944 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
946 say " $sha1 $displaypath$revname"
950 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
951 set_name_rev "$sm_path" "$sha1"
953 say "+$sha1 $displaypath$revname"
956 if test -n "$recursive"
959 prefix="$displaypath/"
962 eval cmd_status "$orig_args"
964 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
969 # Sync remote urls for submodules
970 # This makes the value for remote.$remote.url match the value
971 # specified in .gitmodules.
996 while read mode sha1 stage sm_path
998 name=$(module_name "$sm_path")
999 url=$(git config -f .gitmodules --get submodule."$name".url)
1001 # Possibly a url relative to parent
1004 # rewrite foo/bar as ../.. to find path from
1005 # submodule work tree to superproject work tree
1006 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1007 # guarantee a trailing /
1008 up_path=${up_path%/}/ &&
1009 # path from submodule work tree to submodule origin repo
1010 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1011 # path from superproject work tree to submodule origin repo
1012 super_config_url=$(resolve_relative_url "$url") || exit
1015 sub_origin_url="$url"
1016 super_config_url="$url"
1020 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1022 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
1023 git config submodule."$name".url "$super_config_url"
1025 if test -e "$sm_path"/.git
1030 remote=$(get_default_remote)
1031 git config remote."$remote".url "$sub_origin_url"
1038 # This loop parses the command line arguments to find the
1039 # subcommand name to dispatch. Parsing of the subcommand specific
1040 # options are primarily done by the subcommand implementations.
1041 # Subcommand specific options such as --branch and --cached are
1042 # parsed here as well, for backward compatibility.
1044 while test $# != 0 && test -z "$command"
1047 add | foreach | init | update | status | summary | sync)
1077 # No command word defaults to "status"
1078 test -n "$command" || command=status
1080 # "-b branch" is accepted only by "add"
1081 if test -n "$branch" && test "$command" != add
1086 # "--cached" is accepted only by "status" and "summary"
1087 if test -n "$cached" && test "$command" != status -a "$command" != summary